首页
登录 | 注册

OpenWRT mt7620n 系统升级引起的问题

原文地址:http://blog.csdn.net/qianguozheng/article/details/27237175

OpenWRT系统升级采用 sysupgrade 这个脚本存放在/sbin/sysupgrade.



[html] view plaincopyprint?
  1. #!/bin/sh  
  2. . /lib/functions.sh  
  3.   
  4. # initialize defaults  
  5. RAMFS_COPY_BIN=""   # extra programs for temporary ramfs root  
  6. RAMFS_COPY_DATA=""  # extra data files  
  7. export MTD_CONFIG_ARGS=""  
  8. export INTERACTIVE=0  
  9. export VERBOSE=1  
  10. export SAVE_CONFIG=1  
  11. export SAVE_OVERLAY=0  
  12. export DELAY=  
  13. export CONF_IMAGE=  
  14. export CONF_BACKUP_LIST=0  
  15. export CONF_BACKUP=  
  16. export CONF_RESTORE=  
  17. export NEED_IMAGE=  
  18. export HELP=0  
  19. export FORCE=0  
  20. export TEST=0  
  21.   
  22. # parse options  
  23. while [ -n "$1" ]; do  
  24.     case "$1" in  
  25.         -i) export INTERACTIVE=1;;  
  26.         -d) export DELAY="$2"; shift;;  
  27.         -v) export VERBOSE="$(($VERBOSE + 1))";;  
  28.         -q) export VERBOSE="$(($VERBOSE - 1))";;  
  29.         -n) export SAVE_CONFIG=0;;  
  30.         -c) export SAVE_OVERLAY=1;;  
  31.         -b|--create-backup) export CONF_BACKUP="$2" NEED_IMAGE=1; shift;;  
  32.         -r|--restore-backup) export CONF_RESTORE="$2" NEED_IMAGE=1; shift;;  
  33.         -l|--list-backup) export CONF_BACKUP_LIST=1; break;;  
  34.         -f) export CONF_IMAGE="$2"; shift;;  
  35.         -F|--force) export FORCE=1;;  
  36.         -T|--test) export TEST=1;;  
  37.         -h|--help) export HELP=1; break;;  
  38.         -*)  
  39.             echo "Invalid option: $1"  
  40.             exit 1  
  41.         ;;  
  42.         *) break;;  
  43.     esac  
  44.     shift;  
  45. done  
  46.   
  47. export CONFFILES=/tmp/sysupgrade.conffiles  
  48. export CONF_TAR=/tmp/sysupgrade.tgz  
  49.   
  50. export ARGV="$*"  
  51. export ARGC="$#"  
  52.   
  53. [ -z "$ARGV" -a -z "$NEED_IMAGE" -o $HELP -gt 0 ] && {  
  54.     cat <<EOF  
  55. Usage: $0 [<upgrade-option>...] <image file or URL>  
  56.        $0 [-q] [-i] <backup-command> <file>  
  57.   
  58. upgrade-option:  
  59.     -d <delay>   add a delay before rebooting  
  60.     -f <config>  restore configuration from .tar.gz (file or url)  
  61.     -i           interactive mode  
  62.     -c           attempt to preserve all changed files in /etc/  
  63.     -n           do not save configuration over reflash  
  64.     -T | --test  
  65.                  Verify image and config .tar.gz but do not actually flash.  
  66.     -F | --force  
  67.                  Flash image even if image checks fail, this is dangerous!  
  68.     -q           less verbose  
  69.     -v           more verbose  
  70.     -h | --help  display this help  
  71.   
  72. backup-command:  
  73.     -b | --create-backup <file>  
  74.                  create .tar.gz of files specified in sysupgrade.conf  
  75.                  then exit. Does not flash an image. If file is '-',  
  76.                  i.e. stdout, verbosity is set to 0 (i.e. quiet).  
  77.     -r | --restore-backup <file>  
  78.                  restore a .tar.gz created with sysupgrade -b  
  79.                  then exit. Does not flash an image. If file is '-',  
  80.                  the archive is read from stdin.  
  81.     -l | --list-backup  
  82.                  list the files that would be backed up when calling  
  83.                  sysupgrade -b. Does not create a backup file.  
  84.   
  85. EOF  
  86.     exit 1  
  87. }  
  88.   
  89. [ -n "$ARGV" -a -n "$NEED_IMAGE" ] && {  
  90.     cat <<-EOF  
  91.         -b|--create-backup and -r|--restore-backup do not perform a firmware upgrade.  
  92.         Do not specify both -b|-r and a firmware image.  
  93.     EOF  
  94.     exit 1  
  95. }  
  96.   
  97. # prevent messages from clobbering the tarball when using stdout  
  98. [ "$CONF_BACKUP" = "-" ] && export VERBOSE=0  
  99.   
  100. add_uci_conffiles() {  
  101.     local file="$1"  
  102.     ( find $(sed -ne '/^[[:space:]]*$/d; /^#/d; p' \  
  103.         /etc/sysupgrade.conf /lib/upgrade/keep.d/* 2>/dev/null) \  
  104.         -type f 2>/dev/null;  
  105.       opkg list-changed-conffiles ) | sort -u > "$file"  
  106.     return 0  
  107. }  
  108.   
  109. add_overlayfiles() {  
  110.     local file="$1"  
  111.     find /overlay/etc/ -type f | sed \  
  112.         -e 's,^/overlay/,/,' \  
  113.         -e '\,/META_[a-zA-Z0-9]*$,d' \  
  114.         -e '\,/functions.sh$,d' \  
  115.         -e '\,/[^/]*-opkg$,d' \  
  116.     > "$file"  
  117.     return 0  
  118. }  
  119.   
  120. # hooks  
  121. sysupgrade_image_check="platform_check_image"  
  122. [ $SAVE_OVERLAY = 0 -o ! -d /overlay/etc ] && \  
  123.     sysupgrade_init_conffiles="add_uci_conffiles" || \  
  124.     sysupgrade_init_conffiles="add_overlayfiles"  
  125.   
  126. include /lib/upgrade  
  127.   
  128. do_save_conffiles() {  
  129.     local conf_tar="${1:-$CONF_TAR}"  
  130.   
  131.     [ -z "$(rootfs_type)" ] && {  
  132.         echo "Cannot save config while running from ramdisk."  
  133.         ask_bool 0 "Abort" && exit  
  134.         return 0  
  135.     }  
  136.     run_hooks "$CONFFILES" $sysupgrade_init_conffiles  
  137.     ask_bool 0 "Edit config file list" && vi "$CONFFILES"  
  138.   
  139.     v "Saving config files..."  
  140.     [ "$VERBOSE" -gt 1 ] && TAR_V="v" || TAR_V=""  
  141.     tar c${TAR_V}zf "$conf_tar" -T "$CONFFILES" 2>/dev/null  
  142.   
  143.     rm -f "$CONFFILES"  
  144. }  
  145.   
  146. if [ $CONF_BACKUP_LIST -eq 1 ]; then  
  147.     add_uci_conffiles "$CONFFILES"  
  148.     cat "$CONFFILES"  
  149.     rm -f "$CONFFILES"  
  150.     exit 0  
  151. fi  
  152.   
  153. if [ -n "$CONF_BACKUP" ]; then  
  154.     do_save_conffiles "$CONF_BACKUP"  
  155.     exit $?  
  156. fi  
  157.   
  158. if [ -n "$CONF_RESTORE" ]; then  
  159.     if [ "$CONF_RESTORE" != "-" ] && [ ! -f "$CONF_RESTORE" ]; then  
  160.         echo "Backup archive '$CONF_RESTORE' not found."  
  161.         exit 1  
  162.     fi  
  163.   
  164.     [ "$VERBOSE" -gt 1 ] && TAR_V="v" || TAR_V=""  
  165.     tar -C / -x${TAR_V}zf "$CONF_RESTORE"  
  166.     exit $?  
  167. fi  
  168.   
  169. type platform_check_image >/dev/null 2>/dev/null || {  
  170.     echo "Firmware upgrade is not implemented for this platform."  
  171.     exit 1  
  172. }  
  173.   
  174. for check in $sysupgrade_image_check; do  
  175.     ( eval "$check \"\$ARGV\"" ) || {  
  176.         if [ $FORCE -eq 1 ]; then  
  177.             echo "Image check '$check' failed but --force given - will update anyway!"  
  178.             break  
  179.         else  
  180.             echo "Image check '$check' failed."  
  181.             exit 1  
  182.         fi  
  183.     }  
  184. done  
  185.   
  186. if [ -n "$CONF_IMAGE" ]; then  
  187.     case "$(get_magic_word $CONF_IMAGE cat)" in  
  188.         # .gz files  
  189.         1f8b) ;;  
  190.         *)  
  191.             echo "Invalid config file. Please use only .tar.gz files"  
  192.             exit 1  
  193.         ;;  
  194.     esac  
  195.     get_image "$CONF_IMAGE" "cat" > "$CONF_TAR"  
  196.     export SAVE_CONFIG=1  
  197. elif ask_bool $SAVE_CONFIG "Keep config files over reflash"; then  
  198.     [ $TEST -eq 1 ] || do_save_conffiles  
  199.     export SAVE_CONFIG=1  
  200. else  
  201.     export SAVE_CONFIG=0  
  202. fi  
  203.   
  204. if [ $TEST -eq 1 ]; then  
  205.     exit 0  
  206. fi  
  207.   
  208. run_hooks "" $sysupgrade_pre_upgrade  
  209.   
  210. ubus call system upgrade  
  211. touch /tmp/sysupgrade  
  212.   
  213. if [ ! -f /tmp/failsafe ] ; then  
  214.     kill_remaining TERM  
  215.     sleep 3  
  216.     kill_remaining KILL  
  217. fi  
  218.   
  219. if [ -n "$(rootfs_type)" ]; then  
  220.     v "Switching to ramdisk..."  
  221.     run_ramfs '. /lib/functions.sh; include /lib/upgrade; do_upgrade'  
  222. else  
  223.     do_upgrade  
  224. fi  

源码自己看吧,shell写的东西,我现在也是一知半解,但是不妨碍我解决问题,参照某某某的固件,


在rc.local里面添加了


[html] view plaincopyprint?
  1. ifup -a  

仿照添加后,不起作用。



研习正常固件跑起来的wifi,一般是,

/tmp/RT2860.dat文件存在

/etc/Wireless/RT2860/RT2860.dat 为/tmp/RT2860.dat的软链接

rt2860ap_v2.ko存在

ifconfig 发下ra0也不存在

lsmod查看,ko被引用次数为0.也就是说没有用,重启系统也不起作用。恢复出厂设置就OK了。甚是费解!


初步断定: ra0没有起来,软连接不存在。可能是wireless启动不成功的原因,至于问题究竟出在哪里,我目前还是没有解决。

但是我找到了解决方案,当然这只是临时的,为什么升级后这些数据不在了,需要进一步研究。

对比无线起不来的情况,发现/etc/Wireless/RT2860/RT2860.dat 不存在。就是说软连接可能是在升级过程中转移到另一个临时文件夹,而在系统重启的时候并未建立此文件,因为系统的默认配置/etc/config/wiereless文件已经存在。 

这也许就是root cause,还需验证,我的解决方案是,在rc.local下判断软连接是否存在,不存在则建立此软连接,然后ifup -a

[html] view plaincopyprint?
  1. #detect_rt2860v2函数用于检测是否存在驱动  
  2. detect_rt2860v2() {  
  3. local i=-1  
  4. #判断系统是否存在rt2860v2_ap,不存在则退出  
  5. cd /sys/module/  
  6. [ -d rt2860v2_ap ] || return  
  7. <span style="color:#FF0000;">#检测系统存在多少个wifi接口,                                        
  8. while grep -qs "^ *ra$((++i)):" /proc/net/dev; do  
  9. config_get type ra${i} type  
  10. [ "$type" = rt2860v2 ] && continue  
  11. span>  
  12. <span style="color:#006600;">#检查并创建WiFi驱动配置链接  
  13. [ -f /etc/Wireless/RT2860/RT2860.dat ] || {  
  14. mkdir -p /etc/Wireless/RT2860/  
  15. ln -s /tmp/RT2860.dat /etc/Wireless/RT2860/RT2860.dat  
  16. }  
  17. span>  
  18. first_enable  
  19.   
  20. cat <<EOF  
  21. config wifi-device ra${i}  
  22. option type rt2860v2  
  23. option mode 9  
  24. option channel auto  
  25. option txpower 100  
  26. option ht 20+40  
  27. option country US  
  28. # REMOVE THIS LINE TO ENABLE WIFI:  
  29. option disabled 0  
  30. config wifi-iface  
  31. option device ra${i}  
  32. option network lan  
  33. option mode ap  
  34. option ssid PandoraBox${i#0}_$(cat /sys/class/net/ra${i}/address|awk -F ":" '{print $4""$5""$6 }'| tr a-z A-Z)  
  35. option encryption none  
  36. EOF  
  37.   
  38. ifconfig ra0 down  
  39. done  
  40.   
  41. }  


还需继续研究下启动过程,不然这个问题还是不能真像大白,虽然以上分析其实已经给出了答案。




相关文章


2020 unjeep.com webmaster#unjeep.com
12 q. 0.014 s.
京ICP备10005923号